<?php

	class ISC_PRODUCT
	{

		public $_product = array();

		public $_prodid = 0;
		public $_prodprice = 0;
		public $_prodcalculatedprice = 0;
		public $_prodretailprice = 0;
		public $_prodsaleprice = 0;
		public $_prodimages = 0;
		public $_prodfixedshippingcost = 0;
		public $_prodtype = 0;
		public $_prodweight = 0;
		public $_prodavgrating = 0;
		public $_prodoptionsrequired = 0;
		public $_prodnumreviews = 0;
		public $_prodnumcustomfields = 0;
		public $_prodnumbulkdiscounts = 0;
		public $_prodinvtrack = 0;
		public $_prodcurrentinv = 0;

		public $_prodallowpurchases = 1;
		public $_prodhideprice = 0;
		public $_prodcallforpricinglabel = '';

		public $_prodname = "";
		public $_prodthumb = "";
		public $_proddesc = "";
		public $_prodbrandname = "";
		public $_prodavailability = "";
		public $_prodrelatedproducts = "";
		public $_prodlayoutfile = "";
		public $_prodsku = "";

		public $_prodpagetitle = '';
		public $_prodmetakeywords = '';
		public $_prodmetadesc = '';

		public $_prodfreeshipping = false;
		public $_prodvariations = array();
		public $_prodvariationcombinations = array();
		public $_prodvariationoptions = array();

		public $_prodeventdatelimited;
		public $_prodeventdaterequired;
		public $_prodeventdatefieldname;
		public $_prodeventdatelimitedtype;
		public $_prodeventdatelimitedstartdate;
		public $_prodeventdatelimitedenddate;

		public $_currencyrecord = null;

		public function __construct($productid=0)
		{
			// Load the data for this product
			$this->_SetProductData($productid);

			// Add it to the list of recently viewed products
			if($productid == 0) {
				// We must load the CSS file here for the product details bulk discount thickbox as it needs to be defined before the
				// headers get built
				if (GetConfig('BulkDiscountEnabled') && $this->_prodnumbulkdiscounts > 0) {
					$GLOBALS['AdditionalStylesheets'][] = GetConfig('AppPath').'/javascript/jquery/plugins/imodal/imodal.css';
				}

				$this->_AddToRecentlyViewedProducts();

				// Workout the breadcrumb(s)
				$this->_BuildBreadCrumbs();

				// Track a view for this page
				$this->_TrackView();
			}
		}

		public function _SetProductData($productid=0)
		{

			if ($productid == 0) {
				// Retrieve the query string variables. Can't use the $_GET array
				// because of SEO friendly links in the URL
				SetPGQVariablesManually();
				if (isset($_REQUEST['product'])) {
					$product = $_REQUEST['product'];
				}
				else if(isset($GLOBALS['PathInfo'][1])) {
					$product = preg_replace('#\.html$#i', '', $GLOBALS['PathInfo'][1]);
				}
				else {
					$product = '';
				}

				$product = $GLOBALS['ISC_CLASS_DB']->Quote(MakeURLNormal($product));
				$productSQL = sprintf("p.prodname='%s'", $product);
			}
			else {
				$productSQL = sprintf("p.productid='%s'", (int)$productid);
			}

			$query = "
				SELECT p.*, FLOOR(prodratingtotal/prodnumratings) AS prodavgrating, imageisthumb, imagefile, ".GetProdCustomerGroupPriceSQL().",
				(SELECT COUNT(fieldid) FROM [|PREFIX|]product_customfields WHERE fieldprodid=p.productid) AS numcustomfields,
				(SELECT COUNT(reviewid) FROM [|PREFIX|]reviews WHERE revstatus='1' AND revproductid=p.productid AND revstatus='1') AS numreviews,
				(SELECT brandname FROM [|PREFIX|]brands WHERE brandid=p.prodbrandid) AS prodbrandname,
				(SELECT COUNT(imageid) FROM [|PREFIX|]product_images WHERE imageprodid=p.productid AND imageisthumb=0) AS numimages,
				(SELECT COUNT(discountid) FROM [|PREFIX|]product_discounts WHERE discountprodid=p.productid) AS numbulkdiscounts
				FROM [|PREFIX|]products p
				LEFT JOIN [|PREFIX|]product_images pi ON (pi.imageisthumb=1 AND p.productid=pi.imageprodid)
				WHERE ".$productSQL." AND p.prodvisible='1'
			";
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
			if ($row = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
				$this->_product = $row;
				$this->_prodid = $row['productid'];
				$this->_prodname = $row['prodname'];
				$this->_prodsku = $row['prodcode'];
				$this->_prodthumb = $row['imagefile'];
				$this->_proddesc = $row['proddesc'];
				$this->_prodimages = $row['numimages'];
				$this->_prodprice = $row['prodprice'];
				$this->_prodretailprice = $row['prodretailprice'];
				$this->_prodsaleprice = $row['prodsaleprice'];
				$this->_prodfixedshippingcost = $row['prodfixedshippingcost'];
				$this->_prodbrandname = $row['prodbrandname'];
				$this->_prodweight = $row['prodweight'];
				$this->_prodavgrating = (int)$row['prodavgrating'];
				$this->_prodcalculatedprice = $row['prodcalculatedprice'];
				$this->_prodoptionsrequired = $row['prodoptionsrequired'];
				$this->_prodnumreviews = $row['numreviews'];
				$this->_prodavailability = $row['prodavailability'];
				$this->_prodnumcustomfields = $row['numcustomfields'];
				$this->_prodnumbulkdiscounts = $row['numbulkdiscounts'];
				$this->_prodeventdatelimited = $row['prodeventdatelimited'];
				$this->_prodeventdaterequired = $row['prodeventdaterequired'];
				$this->_prodeventdatefieldname = $row['prodeventdatefieldname'];
				$this->_prodeventdatelimitedtype = $row['prodeventdatelimitedtype'];
				$this->_prodeventdatelimitedstartdate = $row['prodeventdatelimitedstartdate'];
				$this->_prodeventdatelimitedenddate = $row['prodeventdatelimitedenddate'];

				$this->_prodrelatedproducts = $row['prodrelatedproducts'];
				if($row['prodlayoutfile'] != '') {
					$File = str_replace(array(".html", ".htm"), "", $row['prodlayoutfile']);
					if(!file_exists(ISC_BASE_PATH."/templates/".GetConfig('template')."/".$row['prodlayoutfile'])) {
						$this->_prodlayoutfile = 'product';
					}
					else {
						$this->_prodlayoutfile = $File;
					}
				}
				else {
					$this->_prodlayoutfile = 'product';
				}
				$this->_prodpagetitle = $row['prodpagetitle'];
				$this->_prodmetakeywords = $row['prodmetakeywords'];
				$this->_prodmetadesc = $row['prodmetadesc'];
				$this->_prodinvtrack = $row['prodinvtrack'];
				$this->_prodcurrentinv = $row['prodcurrentinv'];

				if ($row['prodtype'] == 1) {
					$this->_prodtype = PT_PHYSICAL;
				} else {
					$this->_prodtype = PT_DIGITAL;
				}

				if ($row['prodfreeshipping'] == 0) {
					$this->_prodfreeshipping = false;
				} else {
					$this->_prodfreeshipping = true;
				}

				$this->_prodallowpurchases = $row['prodallowpurchases'];
				$this->_prodhideprice = $row['prodhideprice'];
				$this->_prodcallforpricinglabel = $row['prodcallforpricinglabel'];

				// If there are product variations, set them up
				if($row['prodvariationid'] > 0) {
					$this->SetupProductVariations();
				}

				$GLOBALS['CurrentProductLink'] = ProdLink($this->_prodname);
			}
		}
		
		public function GetImages()
		{
			$images = array();
			$query = "
				SELECT *
				FROM [|PREFIX|]product_images
				WHERE  imageprodid='".$this->_prodid."' AND imageisthumb='0' 
				ORDER BY imagesort
			";
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
			while ($row = $GLOBALS['ISC_CLASS_DB']->Fetch($result))
				$images[] = $row;                                           
			return $images;
		}

		/**
		*	Track a view for this product by updating the prodnumviews field in the products table
		*/
		public function _TrackView()
		{
			$query = sprintf("update [|PREFIX|]products set prodnumviews=prodnumviews+1 where productid='%d'", $this->_prodid);
			$GLOBALS['ISC_CLASS_DB']->Query($query);
		}

		public function _AddToRecentlyViewedProducts()
		{
			/*
				Store this product's ID in a persistent cookie
				that will be used to remember the last 5 products
				that this person has viewed
			*/

			$viewed_products = array();

			if (isset($_COOKIE['RECENTLY_VIEWED_PRODUCTS'])) {
				$viewed_products = explode(",", $_COOKIE['RECENTLY_VIEWED_PRODUCTS']);
			}

			if (in_array($this->GetProductId(), $viewed_products)) {
				// Remove it from the array
				foreach ($viewed_products as $k=>$v) {
					if ($v == $this->GetProductId()) {
						unset($viewed_products[$k]);
					}
				}
			}

			// Add it to the list
			$viewed_products[] = $this->GetProductId();

			// Only store the 5 most recent product Id's
			if (count($viewed_products) > 5) {
				$reverse_viewed_products = array_reverse($viewed_products);
				$viewed_products = array();

				for ($i = 0; $i < 5; $i++) {
					$viewed_products[] = $reverse_viewed_products[$i];
				}

				// Reverse the array so the oldest products show first
				$viewed_products = array_reverse($viewed_products);
			}

			$new_viewed_products = implode(",", $viewed_products);

			// Persist the cookie for 30 days
			ISC_SetCookie("RECENTLY_VIEWED_PRODUCTS", $new_viewed_products, time() + (3600*24*30));

			// Persist the cookie session-wide for use on the cart page
			$_SESSION['RECENTLY_VIEWED_PRODUCTS'] = $new_viewed_products;
		}

		public function SetupProductVariations()
		{
			// Get a list of product variations for this product from the database
			$optionList = array();
			$query = "
				SELECT *
				FROM [|PREFIX|]product_variation_combinations
				WHERE vcproductid='".$GLOBALS['ISC_CLASS_DB']->Quote($this->GetProductId())."' AND vcenabled='1'
			";
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);

			while ($combination = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
				$variationOptions = explode(",", $combination['vcoptionids']);

				// Product options must be sorted numerically for the javascript selections to work
				sort($variationOptions);

				$combination['vcoptionids'] = implode(",", $variationOptions);
				$this->_prodvariationcombinations[] = $combination;

				// Add the list of options available to the list we'll be selecting below
				$optionList = array_merge($optionList, $variationOptions);
			}

			if(!empty($optionList)) {
				// Fetch the list of option names and values
				$optionList = implode(",", array_unique($optionList));
				$query = "
					SELECT *
					FROM [|PREFIX|]product_variation_options
					WHERE voptionid IN (".$optionList.")
					ORDER BY vooptionsort, vovaluesort
				";
				$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
				$variationNames = array();
				$count = 0;
				while($option = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
					if(!isset($variationNames[$option['voname']])) {
						++$count;
						$variationNames[$option['voname']] = $count;
					}
					else {
						$count = $variationNames[$option['voname']];
					}
					if(!isset($this->_prodvariations[$option['voname']])) {
						$this->_prodvariations[$option['voname']] = array();
					}
					$this->_prodvariations[$option['voname']][] = $option;
					$this->_prodvariationslookup[$option['voptionid']] = $count;
					$this->_prodvariationoptions[$option['voptionid']] = $option;
				}
			}
		}
		public function GetVariationCombination($combination)
		{
			if(!is_array($combination)) {
				$combination = explode(",", $combination);
			}

			// Sort it numerically
			sort($combination, SORT_NUMERIC);
			$combination = implode(",", $combination);

			foreach($this->_prodvariationcombinations as $variation) {
				// Sort this combination numerically too
				$vcombination = explode(",", $variation['vcoptionids']);
				sort($vcombination, SORT_NUMERIC);
				$vcombination = implode(",", $vcombination);
				if($vcombination == $combination) {
					return $variation['combinationid'];
				}
			}

			// Nothing found, return false
			return false;
		}

		public function GetProductVariationCombinationJavascript()
		{
			if(empty($this->_prodvariationcombinations)) {
				return '';
			}
			$script = "<script type=\"text/javascript\">\n";
			$script .= " var VariationList = new Array();\n";

			foreach($this->_prodvariationcombinations as $variation) {
				$variationPrice = CurrencyConvertFormatPrice(CalcProductVariationPrice($this->_prodprice, $variation['vcpricediff'], $variation['vcprice'], $this->_product));

				$youSave = $this->_prodretailprice - CalcProductVariationPrice($this->_prodprice, $variation['vcpricediff'], $variation['vcprice'], $this->_product);
				$variationSaveAmount = '';
				if($youSave > 0) {
					$variationSaveAmount = CurrencyConvertFormatPrice($youSave);
				}

				$variationWeight = FormatWeight(CalcProductVariationWeight($this->_prodweight, $variation['vcweightdiff'], $variation['vcweight']), true);

				if($variation['vcthumb'] != '') {
					$thumb = $GLOBALS['ShopPath']."/".GetConfig('ImageDirectory')."/".$variation['vcthumb'];
				}
				else {
					$thumb = '';
				}
				if($variation['vcimage'] != '') {
					$image = $GLOBALS['ShopPath'].'/'.GetConfig('ImageDirectory').'/'.$variation['vcimage'];
				}
				else {
					$image = '';
				}

				$ids = explode(",", $variation['vcoptionids']);
				$optionList = array();
				foreach($ids as $id) {
					$key = $this->_prodvariationslookup[$id];
					$optionList[$key] = $id;
				}
				ksort($optionList);
				$optionList = implode(",", $optionList);

				$script .= " VariationList[".$variation['combinationid']."] = {";
				$script .= " combination: '".$optionList."', ";
				$script .= " saveAmount: '".$variationSaveAmount."', ";
				$script .= " price: '".$variationPrice."', ";
				$script .= " sku: '".isc_html_escape($variation['vcsku'])."', ";
				$script .= " weight: '".$variationWeight."', ";
				$script .= " thumb: '".$thumb."', ";
				$script .= " image: '".$image."', ";
				// Tracking inventory on a product variation level
				if($this->_prodinvtrack == 2) {
					if(GetConfig('ShowInventory') == 1) {
						$script .= "stock: '".$variation['vcstock']."', ";
					}
					if($variation['vcstock'] <= 0) {
						$script .= " instock: false";
					}
					else {
						$script .= " instock: true";
					}
				}
				else {
					$script .= " instock: true";
				}
				$script .= "};\n";
			}

			$script .= "</script>";
			return $script;

		}

		public function GetProductVariations()
		{
			return $this->_prodvariations;
		}

		public function GetProductInventoryTracking()
		{
			return $this->_prodinvtrack;
		}

		public function GetInventoryLevel()
		{
			return $this->_prodcurrentinv;
		}

		public function IsOptionRequired()
		{
			if ($this->_prodoptionsrequired == 1) {
				return true;
			} else {
				return false;
			}
		}

		public function _BuildBreadCrumbs()
		{
			/*
				Build a list of one or more breadcrumb trails for this
				product based on which categories it appears in
			*/

			// Build the arrays that will contain the category names to build the trails
			$count = 0;

			$GLOBALS['BreadCrumbs'] = "";
			$GLOBALS['FindByCategory'] = "";

			// First we need to fetch the parent lists of all of the categories
			$trailCategories = array();
			$crumbList = array();
			$query = sprintf("
				SELECT c.categoryid, c.catparentlist
				FROM [|PREFIX|]categoryassociations ca
				INNER JOIN [|PREFIX|]categories c ON (c.categoryid=ca.categoryid)
				WHERE ca.productid='%d'",
				$GLOBALS['ISC_CLASS_DB']->Quote($this->GetProductId())
			);
			$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
			while ($row = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
				if ($row['catparentlist'] == '') {
					$row['catparentlist'] = $row['categoryid'];
				}
				$cats = explode(",", $row['catparentlist']);
				$trailCategories = array_merge($trailCategories, $cats);
				$crumbList[$row['categoryid']] = $row['catparentlist'];
			}

			$trailCategories = implode(",", array_unique($trailCategories));
			$categories = array();
			if ($trailCategories != '') {
				// Now load the names for the parent categories from the database
				$query = sprintf("SELECT categoryid, catname FROM [|PREFIX|]categories WHERE categoryid IN (%s)", $trailCategories);
				$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
				while ($row = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
					$categories[$row['categoryid']] = $row['catname'];
				}
			}

			// Now we have all of the information we need to build the trails, lets actually build them
			foreach ($crumbList as $productcatid => $trail) {
				$GLOBALS['CatTrailLink'] = $GLOBALS['ShopPath'];
				$GLOBALS['CatTrailName'] = GetLang('Home');
				$GLOBALS['BreadcrumbItems'] = $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("BreadcrumbItem");
				$GLOBALS['FindByCategoryItems'] = "";

				$cats = explode(",", $trail);
				$breadcrumbitems = "";
				$findbycategoryitems = "";
				$hasAccess = true;

				foreach ($cats as $categoryid) {
					if(!CustomerGroupHasAccessToCategory($categoryid)) {
						/*
						if customer doesn't have access to this category and this category is the category of the product,
						dont print the trail, otherwise just exclude the category from the trail
						*/
						if ($categoryid == $productcatid) {
							$hasAccess = false;
							break;
						}
						continue;
					}
					if (isset($categories[$categoryid])) {
						$catname = $categories[$categoryid];
						$GLOBALS['CatTrailLink'] = CatLink($categoryid, $catname);
						$GLOBALS['CatTrailName'] = isc_html_escape($catname);
						$breadcrumbitems .= $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("BreadcrumbItem");
						$findbycategoryitems .= $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("ProductFindByCategoryItem");
					}
				}

				if ($hasAccess) {
					$GLOBALS['CatTrailName'] = isc_html_escape($this->GetProductName());
					$GLOBALS['BreadcrumbItems'] .= $breadcrumbitems . $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("BreadcrumbItemCurrent");
					$GLOBALS['BreadCrumbs'] .= $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("ProductBreadCrumb");
					$GLOBALS['FindByCategory'] .= $findbycategoryitems . $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("ProductFindByCategory");
				}
			}
		}

		public function HandlePage()
		{
			$this->ShowPage();
		}

		public function HasFreeShipping()
		{
			return $this->_prodfreeshipping;
		}

		public function GetFixedShippingCost()
		{
			return $this->_prodfixedshippingcost;
		}

		public function GetProduct()
		{
			return $this->_product;
		}

		public function GetProductName()
		{
			return $this->_prodname;
		}

		public function GetProductId()
		{
			return $this->_prodid;
		}

		public function GetThumb()
		{
			return $this->_prodthumb;
		}

		public function GetDesc()
		{
			return $this->_proddesc;
		}

		public function GetNumImages()
		{
			return $this->_prodimages;
		}

		public function GetPrice()
		{
			return $this->_prodprice;
		}

		public function GetRetailPrice()
		{
			return $this->_prodretailprice;
		}

		public function GetSalePrice()
		{
			return $this->_prodsaleprice;
		}

		public function GetCalculatedPrice()
		{
			return CalculateProductPrice($this->_product, true, true, false);
		}

		public function GetFinalPrice()
		{
			return CalcProdCustomerGroupPrice($this->_product, $this->_prodcalculatedprice);
		}

		public function GetBrandName()
		{
			return $this->_prodbrandname;
		}

		public function GetProductType()
		{
			return $this->_prodtype;
		}

		public function GetWeight()
		{
			return FormatWeight($this->_prodweight, true);
		}

		public function GetRating()
		{
			return $this->_prodavgrating;
		}

		public function GetNumReviews()
		{
			return $this->_prodnumreviews;
		}

		public function GetSKU()
		{
			return $this->_prodsku;
		}

		public function GetAvailability()
		{
			return $this->_prodavailability;
		}

		public function GetNumCustomFields()
		{
			return $this->_prodnumcustomfields;
		}

		public function GetNumBulkDiscounts()
		{
			return $this->_prodnumbulkdiscounts;
		}

		public function GetEventDateRequired()
		{
			return $this->_prodeventdaterequired;
		}

		public function GetEventDateLimited()
		{
			return $this->_prodeventdatelimited;
		}
		public function GetEventDateFieldName()
		{
			return $this->_prodeventdatefieldname;
		}
		public function GetEventDateLimitedType()
		{
			return $this->_prodeventdatelimitedtype;
		}
		public function GetEventDateLimitedStartDate()
		{
			return $this->_prodeventdatelimitedstartdate;
		}
		public function GetEventDateLimitedEndDate()
		{
			return $this->_prodeventdatelimitedenddate;
		}

		/**
		 * Does this product have usable bulk discounts
		 *
		 * Method will check to see if this product has any bulks discounts without any product variations
		 *
		 * @access public
		 * @return bool TRUE if this product has any usable bulk discounts, FALSE if not
		 */
		public function CanUseBulkDiscounts()
		{
			if (GetConfig('BulkDiscountEnabled') && $this->GetNumBulkDiscounts() > 0 && empty($this->_prodvariations)) {
				return true;
			}

			return false;
		}

		public function GetRelatedProducts()
		{
			// Related products are set to automatic, find them
			return GetRelatedProducts($this->_prodid, $this->_prodname, $this->_prodrelatedproducts);
		}

		public function IsPurchasingAllowed()
		{
			return ($this->_prodallowpurchases && (bool)GetConfig('AllowPurchasing'));
		}

		public function ArePricesHidden()
		{
			if(!GetConfig('ShowProductPrice') || $this->_prodhideprice == 1) {
				return true;
			}

			return false;
		}

		public function GetProductCallForPricingLabel()
		{
			return $this->_prodcallforpricinglabel;
		}

		public function GetPageTitle()
		{
			return $this->_prodpagetitle;
		}

		public function GetProductWarranty()
		{
			return $this->_product['prodwarranty'];
		}

		/**
		 * Get the details of the vendor that this product belongs to (if there are any)
		 *
		 * @return array The details of the vendor. False if there aren't any
		 */
		public function GetProductVendor()
		{
			if(!gzte11(ISC_HUGEPRINT) || $this->_product['prodvendorid'] == 0) {
				return false;
			}

			$vendorCache = $GLOBALS['ISC_CLASS_DATA_STORE']->Read('Vendors');
			if(isset($vendorCache[$this->_product['prodvendorid']])) {
				return $vendorCache[$this->_product['prodvendorid']];
			}

			return false;
		}

		/**
		 * Check if the current product is taxable or not.
		 *
		 * @return boolean True if taxable, false if not.
		 */
		public function GetProductTaxable()
		{
			return $this->_product['prodistaxable'];
		}

		public function BuildTitle()
		{
			$title = '';
			if ($this->GetPageTitle()!="") {
				$title = $this->GetPageTitle();
			} elseif ($this->GetProductName()!="") {
				$title = sprintf("%s - %s", $this->GetProductName(), GetConfig('StoreName'));
			} else {
				$title = sprintf("%s %s", GetConfig('StoreName'), GetLang('Products'));
			}
			return $title;
		}

		public function ShowPage()
		{
			if ($this->_prodid > 0) {
				// Check that the customer has permisison to view this product
				$canView = false;
				$productCategories = explode(',', $this->_product['prodcatids']);
				foreach($productCategories as $categoryId) {
					// Do we have permission to access this category?
					if(CustomerGroupHasAccessToCategory($categoryId)) {
						$canView = true;
					}
				}
				if($canView == false) {
					$noPermissionsPage = GetClass('ISC_403');
					$noPermissionsPage->HandlePage();
					exit;
				}

				if ($this->_prodmetakeywords != "") {
					$GLOBALS['ISC_CLASS_TEMPLATE']->SetMetaKeywords(isc_html_escape($this->_prodmetakeywords));
				}

				if ($this->_prodmetadesc != "") {
					$GLOBALS['ISC_CLASS_TEMPLATE']->SetMetaDescription(isc_html_escape($this->_prodmetadesc));
				}

				$GLOBALS['CompareLink'] = CompareLink();

				// If we're showing images as a lightbox, we need to load up the URLs for the other images for this product
				if(GetConfig('ProductImageMode') == 'lightbox') {
					$GLOBALS['AdditionalStylesheets'][]  = 					GetConfig('ShopPath').'/javascript/jquery/plugins/lightbox/lightbox.css';
				}

				$GLOBALS['ISC_CLASS_TEMPLATE']->SetTemplate($this->_prodlayoutfile);
				$GLOBALS['ISC_CLASS_TEMPLATE']->ParseTemplate();
			}
			// Visiting an invalid product, show a lovely error message
			else {
				ShowInvalidError('product');
				die();
			}
		}

		/**
		 * Check if the current product has tags or not.
		 *
		 * @return boolean True if the product has tags, false if not.
		 */
		public function ProductHasTags()
		{
			return (bool)$this->_product['prodhastags'];
		}

		/**
		 * Can the product be gift wrapped? This depends on two things - are there any gift
		 * wrapping options available and has this product been configured to allow gift wrapping?
		 */
		public function CanBeGiftWrapped()
		{
			if($this->_product['prodwrapoptions'] == -1) {
				return false;
			}
			else {
				$wrapCache = $GLOBALS['ISC_CLASS_DATA_STORE']->Read('GiftWrapping');
				if(!empty($wrapCache)) {
					return true;
				}
			}

			return false;
		}

		public function GetProductFields($productId)
		{
			$fields = array();
			if($productId == 0) {
				return $fields;
			}
			// Get the product fields for this product from the database
			$query = "Select *
					From [|PREFIX|]product_configurable_fields
					Where fieldprodid='".(int)$productId."'
					Order by fieldsortorder ASC";
			$result = $GLOBALS["ISC_CLASS_DB"]->Query($query);

			while ($row = $GLOBALS["ISC_CLASS_DB"]->Fetch($result)) {
				$fields[] = array(
					"id"		=> $row['productfieldid'],
					"name"		=> $row['fieldname'],
					"type"		=> $row['fieldtype'],
					"fileType"	=> $row['fieldfiletype'],
					"fileSize"	=> $row['fieldfilesize'],
					"required"	=> $row['fieldrequired']
				);
			}
			return $fields;
		}

		public function GetEventDateFields()
		{
			return array(
				'prodeventdaterequired' => $this->_product['prodeventdaterequired'],
				'prodeventdatefieldname' => $this->_product['prodeventdatefieldname'],
				'prodeventdatelimited' => $this->_product['prodeventdatelimited'],
				'prodeventdatelimitedtype' => $this->_product['prodeventdatelimitedtype'],
				'prodeventdatelimitedstartdate' => $this->_product['prodeventdatelimitedstartdate'],
				'prodeventdatelimitedenddate' => $this->_product['prodeventdatelimitedenddate'],
			);
		}
	}

?>