<?php

	CLASS ISC_PRODUCTDETAILS_PANEL extends PANEL
	{
		public function SetPanelSettings()
		{
			$GLOBALS['HideProductErrorMessage']='display:none';

			if(isset($_SESSION['ProductErrorMessage']) && $_SESSION['ProductErrorMessage']!='') {
				$GLOBALS['HideProductErrorMessage']='';
				$GLOBALS['ProductErrorMessage']=$_SESSION['ProductErrorMessage'];
				unset($_SESSION['ProductErrorMessage']);
			}

			$GLOBALS['ProductCartQuantity'] = '';
			if(isset($GLOBALS['CartQuantity'.$GLOBALS['ISC_CLASS_PRODUCT']->GetProductId()])) {
				$GLOBALS['ProductCartQuantity'] = (int)$GLOBALS['CartQuantity'.$GLOBALS['ISC_CLASS_PRODUCT']->GetProductId()];
			}

			$GLOBALS['ProductName'] = isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetProductName());
			$GLOBALS['ProductId'] = $GLOBALS['ISC_CLASS_PRODUCT']->GetProductId();
			$GLOBALS['ProductPrice'] = '';

			// Get the vendor information
			$vendorInfo = $GLOBALS['ISC_CLASS_PRODUCT']->GetProductVendor();
			$GLOBALS['HideVendorDetails'] = 'display: none';
			$GLOBALS['VendorName'] = '';
			if(is_array($vendorInfo)) {
				$GLOBALS['HideVendorDetails'] = '';
				$GLOBALS['VendorName'] = '<a href="'.VendorLink($vendorInfo).'">'.isc_html_escape($vendorInfo['vendorname']).'</a>';
			}

			// Can this product be gift wrapped? And do we have any gift wrapping options set up?
			if($GLOBALS['ISC_CLASS_PRODUCT']->CanBeGiftWrapped() && $GLOBALS['ISC_CLASS_PRODUCT']->GetProductType() == PT_PHYSICAL) {
				$GLOBALS['HideGiftWrapMessage'] = '';
				$GLOBALS['GiftWrappingAvailable'] = GetLang('GiftWrappingOptionsAvailable');
			}
			else {
				$GLOBALS['HideGiftWrapMessage'] = 'display: none';
			}

			$thumb = '';
			$GLOBALS['ImagePopupJavascript'] = "showProductImage('".GetConfig('ShopPath')."/productimage.php', ".$GLOBALS['ProductId'].");";

			// If we're showing images as a lightbox, we need to load up the URLs for the other images for this product
			if(GetConfig('ProductImageMode') == 'lightbox') {
				$GLOBALS['AdditionalStylesheets'] = array(
					GetConfig('ShopPath').'/javascript/jquery/plugins/lightbox/lightbox.css'
				);

				$GLOBALS['LightBoxImageList'] = '';
				$query = "
					SELECT imagefile
					FROM [|PREFIX|]product_images
					WHERE imageprodid='".$GLOBALS['ISC_CLASS_PRODUCT']->GetProductId()."' AND imageisthumb=0
					ORDER BY imagesort ASC
				";
				$result = $GLOBALS['ISC_CLASS_DB']->Query($query);
				$i = 0;
				while($image = $GLOBALS['ISC_CLASS_DB']->Fetch($result)) {
					$GLOBALS['LightBoxImageList'] .= '<a id="pictures_'.$i++.'"';
					$GLOBALS['LightBoxImageList'] .= 'href="'.$GLOBALS['ShopPath'].'/'.GetConfig('ImageDirectory').'/'.$image['imagefile'].'" ';
					$GLOBALS['LightBoxImageList'] .= 'title="'.isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetProductName()).'"';
					$GLOBALS['LightBoxImageList'] .= '>&nbsp;</a>';
				}
				$GLOBALS['ImagePopupJavascript'] = "showProductImageLightBox(); return false;";
				$GLOBALS['LightBoxImageJavascript'] = $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet('ProductImagesLightBox');
			}

			//Images
			$product_images = $GLOBALS['ISC_CLASS_PRODUCT']->GetImages();
			if(!empty($product_images))
			{			
				$GLOBALS['ProductImages'] = '';
				$GLOBALS['ProductImages'] .= '
								<script>
										function showProductImageLightBoxById(id) {
											$(\'#LightBoxImages\').html(originalImages);
											initProductLightBox();
											$(\'#LightBoxImages a#\'+id).trigger(\'click\');
										}
								</script>
					';
				foreach($product_images as $k_image => $v_image)
					if($k_image != 0)
						$GLOBALS['ProductImages'] .= '<div style="float:left;margin:10px 5px;"><a href="#" onclick="showProductImageLightBoxById(\'pictures_'.$k_image.'\')"><img src="'.$GLOBALS['ShopPath'].'/phpThumb/phpThumb.php?src=/'.GetConfig('ImageDirectory').'/'.$v_image['imagefile'].'&w=60&q=90" alt=""></a></div>';
				if(count($product_images) > 1)
					$GLOBALS['ProductImages'] .= '<br class="Clear" />';
			}	
			// Is there a thumbnail image we can show?
			$thumb = $GLOBALS['ISC_CLASS_PRODUCT']->GetThumb();
			$thumbImage = '';

			if($thumb == '' && GetConfig('DefaultProductImage') != '') {
				if(GetConfig('DefaultProductImage') == 'template') {
					$thumb = $GLOBALS['IMG_PATH'].'/ProductDefault.gif';
				}
				else {
					$thumb = GetConfig('ShopPath').'/'.GetConfig('DefaultProductImage');
				}
				$thumbImage = '<img src="'.$thumb.'" alt="" />';
			}
			else if($thumb != '') {
				$thumbImage = '<img src="'.GetConfig('ShopPath').'/'.GetConfig('ImageDirectory').'/'.$thumb.'" alt="" />';
			}

			// Is there more than one image? If not, hide the "See more pictures" link
			if ($GLOBALS['ISC_CLASS_PRODUCT']->GetNumImages() == 0) {
				$GLOBALS['HideMorePicturesLink'] = "none";
				$GLOBALS['ThumbImage'] = $thumbImage;
			}
			else {
				$GLOBALS['ThumbImage'] = '<a href="#" onclick="'.$GLOBALS['ImagePopupJavascript'].'">'.$thumbImage.'</a>';

				if ($GLOBALS['ISC_CLASS_PRODUCT']->GetNumImages() == 2) {
					$var = "MorePictures1";
				}
				else if ($GLOBALS['ISC_CLASS_PRODUCT']->GetNumImages() == 1) {
					$var = "SeeLargerImage";
				}
				else {
					$var = "MorePictures2";
				}
				$GLOBALS['SeeMorePictures'] = /*sprintf(GetLang($var), $GLOBALS['ISC_CLASS_PRODUCT']->GetNumImages() - 1)*/'Click to enlarge';
			}

			if($GLOBALS['ISC_CLASS_PRODUCT']->IsPurchasingAllowed()) {
				if(!GetConfig('ShowProductShipping')) {
					$GLOBALS['HideShipping'] = 'none';
				} else if ($GLOBALS['ISC_CLASS_PRODUCT']->GetProductType() == PT_PHYSICAL) {
					if ($GLOBALS['ISC_CLASS_PRODUCT']->GetFixedShippingCost() != 0) {
						// Is there a fixed shipping cost?
						$GLOBALS['ShippingPrice'] = sprintf("%s %s", CurrencyConvertFormatPrice($GLOBALS['ISC_CLASS_PRODUCT']->GetFixedShippingCost()), GetLang('FixedShippingCost'));
					}
					else if ($GLOBALS['ISC_CLASS_PRODUCT']->HasFreeShipping()) {
						// Does this product have free shipping?
						$GLOBALS['ShippingPrice'] = GetLang('FreeShipping');
					}
					else {
						// Shipping calculated at checkout
						$GLOBALS['ShippingPrice'] = GetLang('CalculatedAtCheckout');
					}
				} else {
					$GLOBALS['ShippingPrice'] = GetLang('CalculatedAtCheckout');
				}

				// Is tax already included in this price?
				if(GetConfig('TaxTypeSelected') > 0 && $GLOBALS['ISC_CLASS_PRODUCT']->GetProductTaxable()) {
					if(GetConfig('PricesIncludeTax')) {
						if(GetConfig('TaxTypeSelected') == 2 && GetConfig('DefaultTaxRateName')) { //not included
							$GLOBALS['IncludingExcludingTax'] = sprintf(GetLang('ProductIncludingTax1'), isc_html_escape(GetConfig('DefaultTaxRateName')));
						}
						else {
							$GLOBALS['IncludingExcludingTax'] = GetLang('ProductIncludingTax2');
						}
					}
					else {
						if(GetConfig('TaxTypeSelected') == 2) {
							if(GetConfig('DefaultTaxRateName')) {
								$GLOBALS['IncludingExcludingTax'] = sprintf(GetLang('ProductIncludingTax1'), isc_html_escape(GetConfig('DefaultTaxRateName')));
							}
							else {
								$GLOBALS['IncludingExcludingTax'] = GetLang('ProductIncludingTax2');
							}
						}
						else {
							$GLOBALS['IncludingExcludingTax'] = GetLang('ProductExcludingTax2');
						}
					}
				}

				$GLOBALS['ProductPrice'] = $GLOBALS['ISC_CLASS_PRODUCT']->GetCalculatedPrice();

				if ($GLOBALS['ISC_CLASS_PRODUCT']->GetFinalPrice() < $GLOBALS['ISC_CLASS_PRODUCT']->GetRetailPrice()) {
					$GLOBALS['RetailPrice'] = "<strike>".CurrencyConvertFormatPrice($GLOBALS['ISC_CLASS_PRODUCT']->GetRetailPrice())."</strike>";
					$GLOBALS['PriceLabel'] = GetLang('YourPrice');
					$savings = $GLOBALS['ISC_CLASS_PRODUCT']->GetRetailPrice() - $GLOBALS['ISC_CLASS_PRODUCT']->GetFinalPrice();
					$GLOBALS['YouSave'] = "<span class=\"YouSave\">".sprintf(GetLang('YouSave'), "<span class=
					'YouSaveAmount'>".CurrencyConvertFormatPrice($savings)."</span>")."</span>";
				} else {
					$GLOBALS['PriceLabel'] = GetLang('Price');
					$GLOBALS['HideRRP'] = "none";
				}
			}
			else {
				$GLOBALS['PriceLabel'] = GetLang('Price');
				$GLOBALS['HideShipping'] = 'none';
				if($GLOBALS['ISC_CLASS_PRODUCT']->ArePricesHidden() || !GetConfig('ShowProductPrice')) {
					if($GLOBALS['ISC_CLASS_PRODUCT']->GetProductCallForPricingLabel()) {
						$GLOBALS['ProductPrice'] = $GLOBALS['ISC_CLASS_TEMPLATE']->ParseGL($GLOBALS['ISC_CLASS_PRODUCT']->GetProductCallForPricingLabel());
					}
					else {
						$GLOBALS['HidePrice'] = "display: none;";
					}
				} else {
					$GLOBALS['ProductPrice'] = $GLOBALS['ISC_CLASS_PRODUCT']->GetCalculatedPrice();
				}

				$GLOBALS['HideRRP'] = 'none';
			}

			// Is this product linked to a brand?
			if ($GLOBALS['ISC_CLASS_PRODUCT']->GetBrandName() != "" && GetConfig('ShowProductBrand')) {
				$GLOBALS['BrandName'] = isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetBrandName());
				$GLOBALS['BrandLink'] = BrandLink($GLOBALS['ISC_CLASS_PRODUCT']->GetBrandName());
			}
			else {
				$GLOBALS['HideBrandLink'] = "none";
			}

			if ($GLOBALS['ISC_CLASS_PRODUCT']->GetProductType() == PT_PHYSICAL && GetConfig('ShowProductWeight')) {
				// It's a physical product
				$GLOBALS['ProductWeight'] = $GLOBALS['ISC_CLASS_PRODUCT']->GetWeight();
			}
			else {
				// It's a digital product
				$GLOBALS['HideWeight'] = "none";
			}

			$product = $GLOBALS['ISC_CLASS_PRODUCT']->GetProduct();
			$dimensions = array(
				'ProductHeight' => 'prodheight',
				'ProductWidth' => 'prodwidth',
				'ProductDepth' => 'proddepth'
			);
			foreach($dimensions as $global => $field) {
				if($product[$field] > 0) {
					$GLOBALS[$global] = FormatWeight($product[$field], false);
					$hasDimensions = true;
				}
				else {
					$GLOBALS['Hide'.$global] = 'display: none';
				}
			}

			if(!isset($hasDimensions)) {
				$GLOBALS['HideDimensions'] = 'display: none';
			}

			// Are reviews disabled? Then don't show anything related to reviews
			if(GetConfig('EnableProductReviews') == 0) {
				$GLOBALS['HideReviewLink'] = "none";
				$GLOBALS['HideRating'] = "none";
				$GLOBALS['HideReviews'] = "none";
			}
			else {
				// How many reviews are there?
				if ($GLOBALS['ISC_CLASS_PRODUCT']->GetNumReviews() == 0) {
					$GLOBALS['HideReviewLink'] = "none";
				}
				else {
					$GLOBALS['HideNoReviewsMessage'] = "none";
					if ($GLOBALS['ISC_CLASS_PRODUCT']->GetNumReviews() == 1) {
						$GLOBALS['ReviewLinkText'] = GetLang('ReviewLinkText1');
					} else {
						$GLOBALS['ReviewLinkText'] = sprintf(GetLang('ReviewLinkText2'), $GLOBALS['ISC_CLASS_PRODUCT']->GetNumReviews());
					}
					if (GetConfig('EnableProductTabs')) {
						$GLOBALS['ReviewLinkOnClick'] = "ActiveProductTab('ProductReviews_Tab'); return false;";
					}
				}
			}

			// Has a product availability been given?
			if ($GLOBALS['ISC_CLASS_PRODUCT']->GetAvailability() != "") {
				$GLOBALS['Availability'] = isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetAvailability());
			} else {
				$GLOBALS['HideAvailability'] = "none";
			}

			// Is there an SKU for this product?
			if ($GLOBALS['ISC_CLASS_PRODUCT']->GetSKU() != "" && GetConfig('ShowProductSKU')) {
				$GLOBALS['SKU'] = isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetSKU());
			}
			else {
				$GLOBALS['HideSKU'] = "none";
			}

			if(!GetConfig('ShowProductRating')) {
				$GLOBALS['HideRating'] = "none";
			}

			$GLOBALS['Rating'] = $GLOBALS['ISC_CLASS_PRODUCT']->GetRating();
			$GLOBALS['CartLink'] = CartLink();



			$GLOBALS['ProductId'] = (int) $GLOBALS['ISC_CLASS_PRODUCT']->_prodid;

			$GLOBALS['ImagePage'] = sprintf("%s/productimage.php", $GLOBALS['ShopPath']);

			$GLOBALS['ProductNumReviews'] = (int) $GLOBALS['ISC_CLASS_PRODUCT']->GetNumReviews();

			// Does this product have any bulk discount?
			if ($GLOBALS['ISC_CLASS_PRODUCT']->CanUseBulkDiscounts()) {
				$GLOBALS['HideBulkDiscountLink'] = '';
				$GLOBALS['BulkDiscountThickBoxTitle'] = sprintf(GetLang('BulkDiscountThickBoxTitle'), isc_html_escape($GLOBALS['ISC_CLASS_PRODUCT']->GetProductName()));

				require_once ISC_BASE_PATH.'/includes/display/SideProductAddToCart.php';
				$GLOBALS['BulkDiscountThickBoxRates'] = ISC_SIDEPRODUCTADDTOCART_PANEL::GetProductBulkDiscounts();
				$GLOBALS['ProductBulkDiscountThickBox'] = $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("ProductBulkDiscountThickBox");
			} else {
				$GLOBALS['HideBulkDiscountLink'] = 'none';
			}

			if (GetConfig('ShowInventory') == 1 && $GLOBALS['ISC_CLASS_PRODUCT']->GetProductInventoryTracking() > 0) {
				$GLOBALS['InventoryList'] = '';
				if ($GLOBALS['ISC_CLASS_PRODUCT']->GetProductInventoryTracking() == 2) {
					$variations = $GLOBALS['ISC_CLASS_PRODUCT']->GetProductVariations();
					if (empty($options)) {
						$GLOBALS['HideCurrentStock'] = "display: none;";
					}
				}
				else if ($GLOBALS['ISC_CLASS_PRODUCT']->GetProductInventoryTracking() == 1) {
					$currentStock = $GLOBALS['ISC_CLASS_PRODUCT']->GetInventoryLevel();
					if ($currentStock <= 0) {
						$GLOBALS['InventoryList'] = GetLang('SoldOut');
					}
					else {
						$GLOBALS['InventoryList'] = $currentStock;
					}
				}
			}
			else {
				$GLOBALS['HideCurrentStock'] = "display: none;";
			}

			if(GetConfig('AddToCartButtonPosition') == 'middle' && $GLOBALS['ISC_CLASS_PRODUCT']->IsPurchasingAllowed()) {
				require_once ISC_BASE_PATH.'/includes/display/SideProductAddToCart.php';
				ISC_SIDEPRODUCTADDTOCART_PANEL::LoadAddToCartOptions('middle');
				$GLOBALS['SNIPPETS']['ProductAddToCart'] = $GLOBALS['ISC_CLASS_TEMPLATE']->GetSnippet("ProductAddToCart");
			}

			$GLOBALS['ISC_CLASS_TEMPLATE']->SetPageTitle($GLOBALS['ISC_CLASS_PRODUCT']->BuildTitle());
		}
	}

?>